<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Teacher_Rating extends Controller_UserEnvi {

    public function before() {
        Cookie::set('fD', 'true'); // Без куки файл качаться не будет, типа защита
        parent::before();
    }
    
    // Получить из кука SGID выбранную ранее группу
    private function GetSGID($id)
    {
        # $id = disciplineID
        $SG_ar = json_decode(Cookie::get('SGID', null), true);
        if ($SG_ar !== null) 
        {
            if (array_key_exists($id, $SG_ar))
                return $SG_ar[$id];
        }
        return 0;
    }

    public function action_edit()
    {
        $twig = Twig::factory('teacher/rating');
        $twig->User = $this->UserInfo;
        $id = $this->request->param('id');
        $db = new Model_Teacher_Rating;
		
        // Шапка таблицы: структура УКД (модули и мероприятия)
		$structure = $db->GetMapForDiscipline($this->UserInfo['TeacherID'], $id);

        if($structure->count() == 0)
            throw HTTP_Exception::factory (404, "Для дисциплины с ID $id не создана УКД или такой дисциплины не существует!");
        
		$structureHandled = array();
        $maxRate = 0; $i = 0; $module = 0;

        foreach($structure as $row)
        {
            if($row['ModuleID'] != $module)
            {
                $i++;
                $module = $row['ModuleID'];
            }
            if ($i == 1)
                    $twig->SubjectName = $row['SubjectName'];
            if(!isset($structureHandled[$i]['SubmodulesCount']))
            {
                $structureHandled[$i]['SubmodulesCount'] = 0;
                $structureHandled[$i]['MaxRate'] = 0;
            }
            $j = $structureHandled[$i]['SubmodulesCount'] += 1;
            $structureHandled[$i]['MaxRate'] += (int) $row['MaxRate'];
            $structureHandled[$i]['ModuleTitle'] = $row['ModuleName'];
            $structureHandled[$i]['ModuleType'] = $row['ModuleType'];
            if ($row['ModuleType'] == "exam") {
                $twig->examSubmoduleID = $row['SubmoduleID'];
            }
                    
            $structureHandled[$i][$j]['SubmoduleID'] = $row['SubmoduleID'];
            $structureHandled[$i][$j]['Title'] = $row['SubModuleName'];
            //$structureHandled[$i][$j]['Description'] = $row['SubmoduleDescription']; // Описание
            $structureHandled[$i][$j]['MaxRate'] = (int) $row['MaxRate'];
            $maxRate += $row['MaxRate'];

            if ($row['ModuleType'] == "exam" || $row['ModuleType'] == "extra") {
                $structureHandled[$i][$j]['SubmoduleID'] = -1;
            }
        }
        $structureHandled['ModulesCount'] = $i;
        $structureHandled['MaxRate'] = (int) $maxRate; 

        $twig->headerRate = $structureHandled; 
        //echo debug::vars($structureHandled);
        // end Шапка таблицы


        // Студенты и их баллы
        $students = $db->GetStudentsForRating($this->UserInfo['TeacherID'], $id);

        $rateHandled = array();
        $groupsHandled = array();
        $i_g = 0; $i_s = 0; $curGroup = 0;

        foreach($students as $row) {
            // Группа
            if ($curGroup !== $row['GroupID']) {
                $curGroup = $row['GroupID'];
                $i_g++;
                $rateHandled[$i_g]['GroupID'] = $row['GroupID'];
                $rateHandled[$i_g]['GroupNum'] = $row['GroupNum']; // № группы
                $rateHandled[$i_g]['GradeNum'] = $row['GradeNum']; // № курса
                $rateHandled[$i_g]['isAttached'] = $row['isAttached']; // #1

                if ($row['Degree'] == 'bachelor')
                    $rateHandled[$i_g]['GradeTitle'] = $row['GradeNum'].' курс';

                if ($row['Degree'] == 'specialist')
                    $rateHandled[$i_g]['GradeTitle'] = $row['GradeNum'].' курс';

                if ($row['Degree'] == 'master')
                    $rateHandled[$i_g]['GradeTitle'] = 'Магистратура, '.$row['GradeNum'].' год';

                $groupsHandled[$curGroup] = $rateHandled[$i_g]['GradeTitle']." ".$row['GroupNum']." группа"; 
            }
            // Студенты
            $i_s++;
            $rateHandled[$i_g]['Students'][$i_s]['ID'] = $row['ID'];
            $rateHandled[$i_g]['Students'][$i_s]['Last'] = $row['Last'];
            $rateHandled[$i_g]['Students'][$i_s]['First'] = $row['First'];
            $rateHandled[$i_g]['Students'][$i_s]['Second'] = $row['Second'];
            $rateHandled[$i_g]['Students'][$i_s]['isAttached'] = $row['isAttached']; // #1

            // Баллы студента
            $rate = $db->getMapForStudent($row['ID'], $id);
            $i_r = 0;
            $rateHandled[$i_g]['Students'][$i_s]['RateResult'] = 0;
            foreach($rate as $r) {
                $i_r++;
                $rateHandled[$i_g]['Students'][$i_s]['Rates'][$i_r]['Rate'] = $r['Rate'];
                $rateHandled[$i_g]['Students'][$i_s]['RateResult'] += $r['Rate'];

                if ($r['ModuleType'] == 'exam' || $r['ModuleType'] == 'extra')
                    $rateHandled[$i_g]['Students'][$i_s]['Rates'][$i_r]['SubmoduleID'] = -1;
                else
                    $rateHandled[$i_g]['Students'][$i_s]['Rates'][$i_r]['SubmoduleID'] = $r['SubmoduleID'];
            }
        }

        $twig->rateTable = $rateHandled;
        $twig->groups = $groupsHandled;

        $twig->studyGroupID = $this->GetSGID($id);

        $twig->DisciplineID = $id;

		$this->response->body($twig);
    }

    public function action_exam()
    {
        $twig = Twig::factory('teacher/exam');
        $twig->User = $this->UserInfo;
        $id = $this->request->param('id');
        $db = new Model_Teacher_Rating;

        // Узнаем ExamType TODO
        $dbMap = new Model_Teacher_Map;
        $disc_temp = $dbMap->getDisciplineInfoByID($id);
        $disciplineInfo['ExamType'] = $disc_temp[0]['ExamType'];
        $disciplineInfo['ID'] = $id;
        // END TODO

        // Шапка таблицы: структура УКД (модули и мероприятия)
        $structure = $db->GetMapForDisciplineExam($this->UserInfo['TeacherID'], $id);

        if($structure->count() == 0)
            throw HTTP_Exception::factory (404, "Страница не найдена");

        
        $structureHandled = array();
        $maxRate = 0; $i = 0; $module = 0; $try_1 = 0; // try = 1 - экзамен, = 2, 3 - пересдачи
        $examRate = 0;
        $try = 0;

        foreach($structure as $row)
        {
            if($row['ModuleID'] != $module)
            {
               ++$i;
               $module = $row['ModuleID'];
            }
            if ($i == 1)
                  $twig->SubjectName = $row['SubjectName'];
            if(!isset($structureHandled[$i]['SubmodulesCount']))
            {
                $structureHandled[$i]['SubmodulesCount'] = 0;
                $structureHandled[$i]['MaxRate'] = 0;
            }
            $j = $structureHandled[$i]['SubmodulesCount'] += 1;
            $structureHandled[$i]['MaxRate'] += (int) $row['MaxRate'];
            $structureHandled[$i]['ModuleTitle'] = $row['ModuleName'];
            $structureHandled[$i]['ModuleType'] = $row['ModuleType'];
            if ($row['ModuleType'] == "exam")
                $twig->examSubmoduleID = $row['SubmoduleID'];
                    
            $structureHandled[$i][$j]['SubmoduleID'] = $row['SubmoduleID'];
            if ($row['ModuleType'] == 'extra') {
                $structureHandled[$i][$j]['Title'] = 'Добор баллов';
                $maxRate += $row['MaxRate'];
            }
            else {
                if ($try === 0)
                    $structureHandled[$i][$j]['Title'] = 'Основная сдача';
                else
                    $structureHandled[$i][$j]['Title'] = 'Пересдача '.$try;
                $examRate = $row['MaxRate'];
                $try++;
            }
            //$structureHandled[$i][$j]['Description'] = $row['SubmoduleDescription']; // Описание
            $structureHandled[$i][$j]['MaxRate'] = (int) $row['MaxRate'];
           
        }
        $structureHandled['ModulesCount'] = $i;
        $structureHandled['MaxRate'] = (int) $maxRate; 

        $twig->headerRate = $structureHandled;
        // end Шапка таблицы

        // Студенты и их баллы по экзамену
        $students = $db->GetStudentsForRating($this->UserInfo['TeacherID'], $id);

        $rateHandled = array();
        $groupsHandled = array();
        $i_g = 0; 
        $i_s = 0; 
        $curGroupID = 0;

        foreach($students as $row) {
            // Группа 
            if ($curGroupID !== $row['GroupID']) {
                $curGroupID = $row['GroupID'];
                $i_g++;
                $rateHandled[$i_g]['GroupID'] = $row['GroupID'];
                $rateHandled[$i_g]['GroupNum'] = $row['GroupNum']; // № группы
                $rateHandled[$i_g]['GradeNum'] = $row['GradeNum']; // № курса
                $rateHandled[$i_g]['isAttached'] = $row['isAttached']; // #1

                if ($row['Degree'] == 'bachelor')
                    $rateHandled[$i_g]['GradeTitle'] = $row['GradeNum'].' курс';

                if ($row['Degree'] == 'specialist')
                    $rateHandled[$i_g]['GradeTitle'] = $row['GradeNum'].' курс';

                if ($row['Degree'] == 'master')
                    $rateHandled[$i_g]['GradeTitle'] = 'Магистратура, '.$row['GradeNum'].' год';

                $groupsHandled[$curGroupID] = $rateHandled[$i_g]['GradeTitle']." ".$row['GroupNum']." группа"; 
                $i_s = 0;
            }
            // Студенты
            
            
            $curStudent = array();
            $curStudent['ID'] = $row['ID'];
            $curStudent['Last'] = $row['Last'];
            $curStudent['First'] = $row['First'];
            $curStudent['Second'] = $row['Second'];
            $curStudent['isAttached'] = $row['isAttached']; // #1
            $curStudent['RateResult'] = 0;

            // Баллы студента
            $i_r = 0;
            $examRate = 0;
            $extraNum = 0;
            $rate = $db->getMapForStudentExam($row['ID'], $id);

            $lastExam = -1;
            $lastExtra = -1;
            $lastNilExam = -1;
            $lastNilExtra = -1;

            foreach($rate as $r) {
                
                $curRate = array();
                $curRate['SubmoduleID'] = $r['SubmoduleID'];
                $curRate['Rate'] = $r['Rate'];
                $curRate['ModuleType'] = $r['ModuleType'];

                if (!is_null($r['Rate'])) 
                {
	                if ($r['ModuleType'] == 'exam') {
	        			if ($lastExam >= 0) {
	    					$curStudent['Rates'][$lastExam]['Block'] = 'True';
	        			}
	        			$lastExam = $i_r;
	        		} else if ($r['ModuleType'] == 'extra') {
	        			if ($lastExtra >= 0) {
	    					$curStudent['Rates'][$lastExtra]['Block'] = 'True';
	        			}
	        			$lastExtra = $i_r;
	        			$curStudent['Rate'] += $r['Rate'];
	        		}
        		} else {
    				if ($r['ModuleType'] == 'exam' && $lastNilExam < 0) {
    					$lastNilExam = $i_r;
    				}
					else if ($r['ModuleType'] == 'extra' && $lastNilExtra < 0) {
						$lastNilExtra = $i_r;
					}
					else {
						$curRate['Block'] = 'True';
					}
        		}


                $curStudent['Rates'][$i_r] = $curRate;
                $i_r++;
            }


            $curStudent['RateResult'] += $examRate;
            $total = $db->GetStudentRate($row['ID'], $id);
            $total = $total[0]['Num'];
            if (is_null($total)) $total = 0;
            
            if ($lastExam >= 0) {
        		$curStudent['RateResult'] += $curStudent['Rates'][$lastExam]['Rate'];
            }
            $curStudent['RateSemesterResult'] = $total - $curStudent['RateResult'];
            $curStudent['RateResult'] = $total;

            $magic_bottom = 32;
            $magic_top = 38;

        	if ($lastExtra >= 0) {
	            if ($curStudent['RateSemesterResult'] < $magic_bottom || 
	            	$curStudent['RateSemesterResult'] > $magic_top) 
	            {
	    			$curStudent['Rates'][$lastExtra]['MaxRate'] = 0;	
	            } else {
	            	$curStudent['Rates'][$lastExtra]['MaxRate'] = $magic_top - $curStudent['RateSemesterResult'];
	            }
        		if ($lastNilExtra >= 0) {
        			$curStudent['Rates'][$lastNilExtra]['MaxRate'] = $curStudent['Rates'][$lastExtra]['MaxRate'];
            	}
            }



            
            $rateHandled[$i_g]['Students'][$i_s] = $curStudent;
            $i_s++;

        }

        //echo Debug::vars($structureHandled);
        echo Debug::vars($rateHandled);	
        $twig->rateTable = $rateHandled;
        $twig->groups = $groupsHandled;

        $twig->studyGroupID = $this->GetSGID($id);

        $twig->disciplineInfo = $disciplineInfo;

        $this->response->body($twig);
    }
}
            